<script>
  export let auth
  import { ArrowForward } from '../assets/icons'

  import groups from '../stores/groups'
  import getGroupGradient from '../utils/groupGradient'
  import leaveGroup from '../utils/leaveGroup'
  import { getGroup } from '../api/groups'

  $: group = $groups[auth.id]
  let refreshKey = 1
  $: refreshKey && getGroup(auth.id, auth.secret).catch(e => (error = e))

  $: groupBg = getGroupGradient(auth.id)

  let error
</script>

{#if error}
  <div
    class="max-w-lg w-full min-h-md sm:min-h-lg p-3 mt-6 rounded-lg bg-white
    border-4 border-gray-400 dark:border-gray-800 dark:bg-gray-900">
    <p class="text-lg leading-tight">
      Hubo un error intentando conseguir los datos de
      {#if group}{group.name}{:else}este grupo{/if}
      .
    </p>
    <p class="text-gray-500 text-sm">Error técnico: {error}</p>
    <button
      class="btn btn-outlined mx-auto my-3 block"
      on:click={() => refreshKey++}>
      Reintentar
    </button>
    {#if error === 'forbidden'}
      <button
        class="btn btn-blue mx-auto my-3 block"
        on:click={() => leaveGroup(group, auth)}>
        Irse del grupo
      </button>
    {/if}
  </div>
{:else}
  <button
    class="flex flex-col justify-between items-stretch text-white text-left
    shadow-lg focus:shadow-outline max-w-lg w-full min-h-md sm:min-h-lg p-3 mt-6
    rounded cursor-pointer"
    style={'background-image:' + groupBg}
    on:click|preventDefault={() => (location.hash = `#/groups/${auth.id}`)}>
    <h1 class="font-semibold text-xl sm:text-2xl">
      {group ? group.name : '...'}
    </h1>
    <div class="float-right self-end">
      <span class="flex content-center">
        Ver grupo
        <span class="icon ml-2">
          <ArrowForward props={{ 'aria-hidden': true }} />
        </span>
      </span>
    </div>
  </button>
{/if}
